AnimalsManager = {};

AnimalsManager.metadata = {
	interface = " FS19 1.x",
	title = " AnimalsManager",
	notes = " Ändert/Setzt/Aktiviert Animals Values",
	author = " (by HappyLooser)",
	version = " v0.3 Beta",
	datum = " 24.12.2018",
	update = " 16.01.2019",
	web = " no",
	info = " Link Freigabe,Änderungen,Kopien oder Code Benutzung ist ohne meine Zustimmung nicht erlaubt",
	"##Orginal Link Freigabe:"
};

AnimalsManager.modDir = g_currentModDirectory;
function AnimalsManager:loadMap(name)
	g_currentMission.AnimalsManager = AnimalsManager;	
	print("---loading".. tostring(AnimalsManager.metadata.title).. tostring(AnimalsManager.metadata.version).. tostring(AnimalsManager.metadata.author).. "---")
	--if isServer() then return;end;
	AnimalsManager.settingsDir = getUserProfileAppPath().. "modsSettings/AnimalsManager/";	
	AnimalsManager.mpHostServer = {animalPlaceableLimit=20, animalVisualLimit=10, animalCleanLinessOff="", animalCleanLinessOn=false};	
	AnimalsManager.singlePlayer = {animalPlaceableLimit=30, animalVisualLimit=10, animalCleanLinessOff="", animalCleanLinessOn=false};
	AnimalsManager.mpDetiServer = {animalPlaceableLimit=100, animalVisualLimit=10, animalCleanLinessOff="", animalCleanLinessOn=false};	
	AnimalsManager.hlDebugMode = false;
	AnimalsManager.updateVisual = false;
	AnimalsManager.indexToAnimals = {};
	AnimalsManager.indexToAnimalsModule = {};
	AnimalsManager:setGetCfg(true);
	if AnimalsManager:isHostMp() then
		AnimalsManager.mpDetiServer.animalCleanLinessOff = AnimalsManager.mpHostServer.animalCleanLinessOff;
		AnimalsManager.mpDetiServer.animalVisualLimit = AnimalsManager.mpHostServer.animalVisualLimit;
		AnimalsManager.mpDetiServer.animalPlaceableLimit = AnimalsManager.mpHostServer.animalPlaceableLimit;
		AnimalsManager.mpDetiServer.animalCleanLinessOn = AnimalsManager.mpHostServer.animalCleanLinessOn;
	end;
	AnimalsManager.isLoadMap = false;
	AnimalsManager:init();
end;

function AnimalsManager:deleteMap()
	if isServer() then return;end;
	AnimalsManager:setGetCfg(false);	
end;

function AnimalsManager:mouseEvent(posX, posY, isDown, isUp, button)
end;

function AnimalsManager:keyEvent(unicode, sym, modifier, isDown)
	--if isServer() then return;end;	
end;

function AnimalsManager:update(dt)	
	if isServer() then return;end;	
	if not AnimalsManager.isLoadMap and not isServer() and not AnimalsManager:isHostMp() and AnimalsManager:isMp() then AnimalsManagerEvent.sendEvent("", true);end;
	if not AnimalsManager.isLoadMap then AnimalsManager.isLoadMap = true;end;
end;

function AnimalsManager:draw(dt)
	--if isServer() then return;end;	
end;

function AnimalsManager:init()
	AnimalsManager:setGetCfg(false)
	source(AnimalsManager.modDir.."_hl.lua");	
end;
addModEventListener(AnimalsManager);

function isServer()
	return g_server ~= nil and g_client ~= nil and g_dedicatedServerInfo ~= nil;
end;

function AnimalsManager:isMp()
	return g_currentMission.missionDynamicInfo.isMultiplayer;	
end;

function AnimalsManager:isHostMp()
	return AnimalsManager:isMp() and g_server ~= nil and g_client ~= nil and g_dedicatedServerInfo == nil;
end;

function AnimalsManager:setVisual(animals)	
	function setVisual(animal)		
		if isServer() or AnimalsManager:isMp() then
			local updateVisual = (isServer() and animal.maxNumVisualAnimals > AnimalsManager.mpDetiServer.animalVisualLimit	and not AnimalsManager.updateVisual) or (not AnimalsManager.isMp() and animal.maxNumVisualAnimals > AnimalsManager.singlePlayer.animalVisualLimit and not AnimalsManager.updateVisual);		
			animal.maxNumVisualAnimals=AnimalsManager.mpDetiServer.animalVisualLimit;
			if updateVisual then AnimalsManager.updateVisual=true;HusbandryModuleAnimal:updateVisualAnimals();end;			
		elseif not AnimalsManager:isMp() then 
			animal.maxNumVisualAnimals=AnimalsManager.singlePlayer.animalVisualLimit;
		end;
	end;
	if animals ~= nil then
		setVisual(animals)
	elseif AnimalsManager.indexToAnimalsModule ~= nil then
		for key, animalObject in pairs(AnimalsManager.indexToAnimalsModule) do			
			setVisual(animalObject)
		end;
	end;
end;

local oldHusbandryModuleAnimal = HusbandryModuleAnimal.load; 
HusbandryModuleAnimal.load = function(self, xmlFile, configKey, rootNode, owner)
	local isOkay, result = pcall(oldHusbandryModuleAnimal, self, xmlFile, configKey, rootNode, owner);	
	if isOkay then
		if self ~= nil and self.animalType ~= "HORSE" and self.animalType ~= "DOG" then 
			table.insert(AnimalsManager.indexToAnimalsModule, self);
			if AnimalsManager.isLoadMap then
				AnimalsManager:setVisual(self);
			end;
		end;		
		return result;	
	end;
	return false;	
end;


function AnimalsManager:setCleanLiness(animals)		
	function setCleanLiness(animal)
		if animal.animalType == "HORSE" then return;end;	
		local foodSpillageModule = animal:getModuleByName("foodSpillage");
		local animalsModule = animal:getModuleByName("animals");
		if foodSpillageModule ~= nil and animalsModule ~= nil then
			local animalName = tostring(animalsModule:getAnimalType():lower());
			local isCleanLiness = nil;
			if isServer() or (AnimalsManager:isMp()) and string.len(AnimalsManager.mpDetiServer.animalCleanLinessOff) > 0 then isCleanLiness = string.find(animalName, AnimalsManager.mpDetiServer.animalCleanLinessOff);elseif not AnimalsManager:isMp() and string.len(AnimalsManager.singlePlayer.animalCleanLinessOff) > 0 then isCleanLiness = string.find(animalName, AnimalsManager.singlePlayer.animalCleanLinessOff);end;
			if foodSpillageModule.hasCleanliness ~= nil and foodSpillageModule.hasCleanliness and isCleanLiness ~= nil and isCleanLiness then 
				foodSpillageModule.hasCleanliness = false;
			elseif foodSpillageModule.hasCleanliness ~= nil and not foodSpillageModule.hasCleanliness and isCleanLiness ~= nil and not isCleanLiness then
				if (isServer() or (AnimalsManager:isMp()) and AnimalsManager.mpDetiServer.animalCleanLinessOn) or (not AnimalsManager:isMp() and AnimalsManager.singlePlayer.animalCleanLinessOn) then 
					foodSpillageModule.hasCleanliness = true;
				end;
			end;			
		end;
	end;
	if animals ~= nil then
		setCleanLiness(animals);
	elseif AnimalsManager.indexToAnimals ~= nil then 
		for key, animalObject in pairs(AnimalsManager.indexToAnimals) do			
			setCleanLiness(animalObject)
		end;
	end;	
end;


local oldAnimalHusbandry = AnimalHusbandry.load; 
AnimalHusbandry.load = function(self, xmlFilename, x, y, z, rx, ry, rz, initRandom)	
	if AnimalsManager.isMp then AnimalHusbandry.GAME_LIMIT = AnimalsManager.mpDetiServer.animalPlaceableLimit;else AnimalHusbandry.GAME_LIMIT = AnimalsManager.singlePlayer.animalPlaceableLimit;end;
	local isOkay, result = pcall(oldAnimalHusbandry, self, xmlFilename, x, y, z, rx, ry, rz, initRandom);
	if isOkay and self ~= nil and self.nodeId ~= nil and self.nodeId > 0 then		
		if self.animalType ~= "DOG" then			
			table.insert(AnimalsManager.indexToAnimals, self);			
			if AnimalsManager.isLoadMap then
				AnimalsManager:setCleanLiness(self);
			end;
		end;
		return result;
	end;
	return false;
end;

function AnimalsManager:get_hl(args, argsTable, errorTxtCall) --args hl table, argsTable a table with all args Values, errorTxt a Value for debug print
	local isOkay, result, argsError, errorTxt = nil,nil,nil,errorTxtCall;
	if AnimalsManager.hlDebugMode and (errorTxtCall == nil or type(errorTxtCall) ~= "string" or string.len(errorTxtCall) == 0) then errorTxt = "Unknown";end;
	local foundArgsError = false;
	if type(argsTable) == "table" or g_currentMission.hl[args] ~= nil or #argsTable > 0 then	
		isOkay, result = pcall(g_currentMission.hl[args], unpack(argsTable));
	else
		foundArgsError = true;
	end;
	if AnimalsManager.hlDebugMode and foundArgsError then isOkay=false;argsError="Unknown args or argsTable or argsTable = 0";end;		
	if AnimalsManager.hlDebugMode and (not isOkay or foundArgsError) then AnimalsManager:setDebug("AnimalsManagerMod", args or "Unknown", errorTxt, argsError or "No args error", result or "NO result error");end;
	return result, isOkay;	
end;

function AnimalsManager:setDebug(argsMod, args1, errorTxt, args2, args3)	
	if g_currentMission.hl.debug == nil then g_currentMission.hl.debug = {};end;
	if g_currentMission.hl.debug[argsMod] == nil then g_currentMission.hl.debug[argsMod] = {};end;
	local errorString = "Trigger: ".. tostring(args1).. " -errorTxtCall: ".. tostring(errorTxt).. " -argsError: ".. tostring(args2).. " -resultError: ".. tostring(args3);
	local alreadyExists = false;
	if #g_currentMission.hl.debug[argsMod] == 0 then table.insert(g_currentMission.hl.debug[argsMod], tostring(errorString));else
		for key,value in pairs(g_currentMission.hl.debug[argsMod]) do			
			if tostring(value) == errorString and string.len(value) == string.len(errorString) then alreadyExists=true;break;end;			
		end;		
		if not alreadyExists then table.insert(g_currentMission.hl.debug[argsMod], tostring(errorString));end;
	end;	
end;

function AnimalsManager:setGetCfg(loadCfg)
	if not isServer() then
		createFolder(getUserProfileAppPath().. "modsSettings/");
		createFolder(AnimalsManager.settingsDir);
	end;
	local file = AnimalsManager.settingsDir.. "animalsManagerSettings.xml";
	if isServer() then file = getUserProfileAppPath().. "animalsManagerSettings.xml";end;
	local Xml = nil;
	local xmlVersion = 0.1;
	if not fileExists(file) or not loadCfg then
		Xml = createXMLFile("AnimalsManager_XML", file, "animalsManagerSettings");		
		local groupNameTag = ("AnimalsManagerSettings.version(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#xmlVersion", tostring(xmlVersion));
		local groupNameTag = ("AnimalsManagerSettings.global(%d)"):format(0);		
		setXMLBool(Xml, groupNameTag.. "#hlDebugMode", AnimalsManager.hlDebugMode);		
		
		local groupNameTag = ("AnimalsManagerSettings.acceptsAnimalCleanLinessOff(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#info", "pig sheep cow chicken horse or animal mods(register animal name)");		
		
		local groupNameTag = ("AnimalsManagerSettings.singlePlayer.animalPlaceableLimit(%d)"):format(0);
		setXMLInt(Xml, groupNameTag.. "#int", AnimalsManager.singlePlayer.animalPlaceableLimit);
		local groupNameTag = ("AnimalsManagerSettings.singlePlayer.animalVisualLimit(%d)"):format(0);
		setXMLInt(Xml, groupNameTag.. "#int", AnimalsManager.singlePlayer.animalVisualLimit);
		local groupNameTag = ("AnimalsManagerSettings.singlePlayer.animalCleanLinessOff(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#string", AnimalsManager.singlePlayer.animalCleanLinessOff);
		local groupNameTag = ("AnimalsManagerSettings.singlePlayer.animalCleanLinessOn(%d)"):format(0);		
		setXMLBool(Xml, groupNameTag.. "#boolean", AnimalsManager.singlePlayer.animalCleanLinessOn);		
		
		local groupNameTag = ("AnimalsManagerSettings.mpHostServer.animalPlaceableLimit(%d)"):format(0);
		setXMLInt(Xml, groupNameTag.. "#int", AnimalsManager.mpHostServer.animalPlaceableLimit);
		local groupNameTag = ("AnimalsManagerSettings.mpHostServer.animalVisualLimit(%d)"):format(0);
		setXMLInt(Xml, groupNameTag.. "#int", AnimalsManager.mpHostServer.animalVisualLimit);
		local groupNameTag = ("AnimalsManagerSettings.mpHostServer.animalCleanLinessOff(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#string", AnimalsManager.mpHostServer.animalCleanLinessOff);
		local groupNameTag = ("AnimalsManagerSettings.mpHostServer.animalCleanLinessOn(%d)"):format(0);		
		setXMLBool(Xml, groupNameTag.. "#boolean", AnimalsManager.mpHostServer.animalCleanLinessOn);
		
		if isServer() and fileExists(file) then
			local groupNameTag = ("AnimalsManagerSettings.mpDetiServer.animalPlaceableLimit(%d)"):format(0);
			setXMLInt(Xml, groupNameTag.. "#int", AnimalsManager.mpDetiServer.animalPlaceableLimit);
			local groupNameTag = ("AnimalsManagerSettings.mpDetiServer.animalVisualLimit(%d)"):format(0);
			setXMLInt(Xml, groupNameTag.. "#int", AnimalsManager.mpDetiServer.animalVisualLimit);
			local groupNameTag = ("AnimalsManagerSettings.mpDetiServer.animalCleanLinessOff(%d)"):format(0);
			setXMLString(Xml, groupNameTag.. "#string", AnimalsManager.mpDetiServer.animalCleanLinessOff);
			local groupNameTag = ("AnimalsManagerSettings.mpDetiServer.animalCleanLinessOn(%d)"):format(0);		
			setXMLBool(Xml, groupNameTag.. "#boolean", AnimalsManager.mpDetiServer.animalCleanLinessOn);	
		end;
		if isServer() and not fileExists(file) then
			local groupNameTag = ("AnimalsManagerSettings.mpDetiServer.animalPlaceableLimit(%d)"):format(0);
			AnimalsManager.mpDetiServer.animalPlaceableLimit = 25;
			setXMLInt(Xml, groupNameTag.. "#int", AnimalsManager.mpDetiServer.animalPlaceableLimit);
			local groupNameTag = ("AnimalsManagerSettings.mpDetiServer.animalVisualLimit(%d)"):format(0);
			AnimalsManager.mpDetiServer.animalVisualLimit = 10;
			setXMLInt(Xml, groupNameTag.. "#int", AnimalsManager.mpDetiServer.animalVisualLimit);
			local groupNameTag = ("AnimalsManagerSettings.mpDetiServer.animalCleanLinessOff(%d)"):format(0);
			AnimalsManager.mpDetiServer.animalCleanLinessOff = "";
			setXMLString(Xml, groupNameTag.. "#string", AnimalsManager.mpDetiServer.animalCleanLinessOff);
			local groupNameTag = ("AnimalsManagerSettings.mpDetiServer.animalCleanLinessOn(%d)"):format(0);		
			AnimalsManager.mpDetiServer.animalCleanLinessOn = false;
			setXMLBool(Xml, groupNameTag.. "#boolean", AnimalsManager.mpDetiServer.animalCleanLinessOn);	
		end;
		saveXMLFile(Xml);
	else	
		Xml = loadXMLFile("AnimalsManager_XML", file, "animalsManagerSettings");
		local groupNameTag = ("animalsManagerSettings.version(%d)"):format(0);
		if not getXMLString(Xml, groupNameTag.. "#xmlVersion") then AnimalsManager:saveOldXml();AnimalsManager:setGetCfg(false)return;end;
		local xmlVersionTemp = string.format("%1.1f", "".. getXMLString(Xml, groupNameTag.. "#xmlVersion"));		
		if tonumber(xmlVersionTemp) < tonumber(xmlVersion) then AnimalsManager:saveOldXml();AnimalsManager:setGetCfg(false)return;end;
		local groupNameTag = ("AnimalsManagerSettings.global(%d)"):format(0);		
		if getXMLBool(Xml, groupNameTag.. "#hlDebugMode") ~= nil then AnimalsManager.hlDebugMode = getXMLBool(Xml, groupNameTag.. "#hlDebugMode");end;
								
		local groupNameTag = ("AnimalsManagerSettings.singlePlayer.animalPlaceableLimit(%d)"):format(0);		
		if getXMLInt(Xml, groupNameTag.. "#int") then AnimalsManager.singlePlayer.animalPlaceableLimit = getXMLInt(Xml, groupNameTag.. "#int");end;
		local groupNameTag = ("AnimalsManagerSettings.singlePlayer.animalVisualLimit(%d)"):format(0);		
		if getXMLInt(Xml, groupNameTag.. "#int") then AnimalsManager.singlePlayer.animalVisualLimit = getXMLInt(Xml, groupNameTag.. "#int");end;
		local groupNameTag = ("AnimalsManagerSettings.singlePlayer.animalCleanLinessOff(%d)"):format(0);		
		if getXMLString(Xml, groupNameTag.. "#string") then AnimalsManager.singlePlayer.animalCleanLinessOff = getXMLString(Xml, groupNameTag.. "#string"):lower();end;
		local groupNameTag = ("AnimalsManagerSettings.singlePlayer.animalCleanLinessOn(%d)"):format(0);		
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then AnimalsManager.singlePlayer.animalCleanLinessOn = getXMLBool(Xml, groupNameTag.. "#boolean");end;
				
		local groupNameTag = ("AnimalsManagerSettings.mpHostServer.animalPlaceableLimit(%d)"):format(0);		
		if getXMLInt(Xml, groupNameTag.. "#int") then AnimalsManager.mpHostServer.animalPlaceableLimit = getXMLInt(Xml, groupNameTag.. "#int");end;
		local groupNameTag = ("AnimalsManagerSettings.mpHostServer.animalVisualLimit(%d)"):format(0);		
		if getXMLInt(Xml, groupNameTag.. "#int") then AnimalsManager.mpHostServer.animalVisualLimit = getXMLInt(Xml, groupNameTag.. "#int");end;
		local groupNameTag = ("AnimalsManagerSettings.mpHostServer.animalCleanLinessOff(%d)"):format(0);		
		if getXMLString(Xml, groupNameTag.. "#string") then AnimalsManager.mpHostServer.animalCleanLinessOff = getXMLString(Xml, groupNameTag.. "#string"):lower();end;
		local groupNameTag = ("AnimalsManagerSettings.mpHostServer.animalCleanLinessOn(%d)"):format(0);		
		if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then AnimalsManager.mpHostServer.animalCleanLinessOn = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		
		if isServer() then
			local groupNameTag = ("AnimalsManagerSettings.mpDetiServer.animalPlaceableLimit(%d)"):format(0);		
			if getXMLInt(Xml, groupNameTag.. "#int") then AnimalsManager.mpDetiServer.animalPlaceableLimit = getXMLInt(Xml, groupNameTag.. "#int");end;
			if AnimalsManager.mpDetiServer.animalPlaceableLimit > 100 then AnimalsManager.mpDetiServer.animalPlaceableLimit = 100;end;
			local groupNameTag = ("AnimalsManagerSettings.mpDetiServer.animalVisualLimit(%d)"):format(0);		
			if getXMLInt(Xml, groupNameTag.. "#int") then AnimalsManager.mpDetiServer.animalVisualLimit = getXMLInt(Xml, groupNameTag.. "#int");end;
			local groupNameTag = ("AnimalsManagerSettings.mpDetiServer.animalCleanLinessOff(%d)"):format(0);		
			if getXMLString(Xml, groupNameTag.. "#string") then AnimalsManager.mpDetiServer.animalCleanLinessOff = getXMLString(Xml, groupNameTag.. "#string"):lower();end;
			local groupNameTag = ("AnimalsManagerSettings.mpDetiServer.animalCleanLinessOn(%d)"):format(0);		
			if getXMLBool(Xml, groupNameTag.. "#boolean") ~= nil then AnimalsManager.mpDetiServer.animalCleanLinessOn = getXMLBool(Xml, groupNameTag.. "#boolean");end;
		end;
	end;	
end;

function AnimalsManager:saveOldXml()	
	if isServer() then return;end;
	local getDateString = tostring(getDate("%d").. "_".. getDate("%w").. "_".. getDate("%m").. "_".. getDate("%Y"));
	local oldXml = AnimalsManager.settingsDir.. "animalsManagerSettings.xml";	
	local backupXml = AnimalsManager.settingsDir.. "animalsManagerSettings_Old_Backup_".. getDateString.. ".xml";	
	copyFile(oldXml, backupXml, false);
end;	